---
title: Xamarin.Android error ADB0040
description: ADB0040 error code
ms.date: 07/04/2018
---
# Xamarin.Android error ADB0040

## Example messages

```
error ADB0040: Failure [INSTALL_FAILED_OLDER_SDK]
```

## Issue

ADB0040 means that you are trying to deploy to an emulator or device
that has an older Android version than what your Xamarin.Android
application supports.

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

## Solution

Verify you are setting the appropriate values for `uses-sdk` in your
*AndroidManifest.xml*:

```xml
<uses-sdk android:minSdkVersion="15" android:targetSdkVersion="27"/>
```

Your attached device must at least be able to support `minSdkVersion`.

[adb]: https://developer.android.com/studio/command-line/adb

## Implementation notes

Note that nothing in the open source xamarin-android repository
emits ADB0040, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android additions.
