---
title: Xamarin.Android error ADB0060
description: ADB0060 error code
ms.date: 07/04/2018
---
# Xamarin.Android error ADB0060

## Example messages

```
error ADB0060: Failure [INSTALL_FAILED_INSUFFICIENT_STORAGE]
```

```
error ADB0060: Failure [INSTALL_FAILED_MEDIA_UNAVAILABLE]
```

## Issue

ADB0060 means that the internal or external disk space is full on
your Android emulator or device.

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

## Solutions

Consider uninstalling applications or adding an SD card for additional
storage.

[adb]: https://developer.android.com/studio/command-line/adb

## Implementation notes

Note that nothing in the open source xamarin-android repository
emits ADB0060, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android additions.
